// AresLinkViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AresLinkViewer.h"
#include "AresLinkViewerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

inline void d67(const BYTE* S, int len, WORD b, BYTE* R)
{
	for ( int i = 0; i < len; i ++ )
	{
        R[ i ] = S[ i ] ^ (BYTE)( b >> 8 );
        b = ( S[ i ] + b ) * 23219 + 36126;
	}
}

inline CString toBase32(const BYTE* hash, DWORD byteCount)
{
	const WCHAR base32[] = L"ABCDEFGHIJKLMNOPQRSTUVWXYZ234567=";
	const DWORD base32Chars = ( byteCount * CHAR_BIT + 4 ) / 5;
	WCHAR result[ ( 24 * CHAR_BIT + 4 ) / 5 + 1 ];

	int shift = 11;
	DWORD i = 0, ch = 0;
	do
	{
		result[ ch ] = base32[ ( ( hash[ i ] * 256 + hash[ i + 1 ] )
			>> shift ) & 0x1f ];
		shift -= 5;
		if ( shift <= 0 )
		{
			shift += CHAR_BIT;
			++i;
		}
	}
	while ( ++ch < base32Chars - 1 );

	result[ base32Chars - 1 ]
			= base32[ ( hash[ byteCount - 1 ]
					<< ( base32Chars * 5 % CHAR_BIT ) ) & 0x1f ];
	result[ base32Chars ] = 0;
	return result;
}

// CAresLinkViewerDlg dialog

CAresLinkViewerDlg::CAresLinkViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAresLinkViewerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	/*/ Test d67()
	{
		const BYTE S[ 16 ] = { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F };
		const WORD b = 15701;
		const BYTE R[ 16 ] = { 0x3D, 0x50, 0x7D, 0xEB, 0x13, 0x4D, 0x9E, 0x91, 0x29, 0xDF, 0x35, 0x9F, 0xC5, 0x73, 0xCF, 0x08 };
		BYTE out[ 16 ] = {};
		d67( S, 16, b, out );
		ASSERT( memcmp( out, R, 16 ) == 0 );
	}
	{
		const BYTE S[ 16 ] = { 0x3D, 0x50, 0x7D, 0xEB, 0x13, 0x4D, 0x9E, 0x91, 0x29, 0xDF, 0x35, 0x9F, 0xC5, 0x73, 0xCF, 0x08 };
		const WORD b = 27357;
		const BYTE R[ 16 ] = { 0x57, 0xC4, 0x33, 0xFC, 0x6B, 0x93, 0x7A, 0x4A, 0x06, 0x72, 0xDE, 0xC8, 0xAD, 0x22, 0x26, 0x21 };
		BYTE out[ 16 ] = {};
		d67( S, 16, b, out );
		ASSERT( memcmp( out, R, 16 ) == 0 );
	}*/
}

void CAresLinkViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_INPUT, m_sInput);
	DDX_Text(pDX, IDC_OUTPUT, m_sOutput);
}

BEGIN_MESSAGE_MAP(CAresLinkViewerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_INPUT, &CAresLinkViewerDlg::OnEnChangeInput)
	ON_BN_CLICKED(IDOK, &CAresLinkViewerDlg::OnBnClickedOk)
END_MESSAGE_MAP()

BOOL CAresLinkViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAresLinkViewerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CAresLinkViewerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CAresLinkViewerDlg::OnEnChangeInput()
{
	OnBnClickedOk();
}

void CAresLinkViewerDlg::OnBnClickedOk()
{
	CString foo;

	UpdateData();

	m_sInput.Remove( _T('\r') );
	m_sInput.Remove( _T('\n') );
	m_sInput.Trim();
	m_sOutput.Empty();

	if ( m_sInput.Left( 8 ).CompareNoCase( _T("arlnk://") ) == 0)
	{
		// DeBASE64
		BYTE inBuffer[ 1024 ] = {};
		int inSize = 1024;
		CT2CA input( (LPCTSTR)m_sInput + 8 );
		if ( Base64Decode( input, lstrlenA( input ), inBuffer, &inSize ) )
		{
			// Decrypt
			BYTE inBufferDec[ 1024 ] = {};
			d67( inBuffer, inSize, 28435, inBufferDec );

			// Decompress
			BYTE outBuffer[ 1024 ] = {};
			int outSize = 1024;
			z_stream zstream = {};
			zstream.next_in = inBufferDec;
			zstream.avail_in = inSize;
			zstream.next_out = outBuffer;
			zstream.avail_out = outSize;
			inflateInit( &zstream );
			int res = inflate( &zstream, Z_FINISH );
			int outSizeZip = zstream.total_out;
			inflateEnd( &zstream );
			if ( res == Z_STREAM_END )
			{
				// Skip unused MD5
				const BYTE* pBuffer = outBuffer + 16;
				int nBuffer = outSizeZip - 16;

				// 32-bit file size
				unsigned __int64 nFileSize = *(DWORD*)pBuffer;
				pBuffer += 4; nBuffer -= 4;

				// File name
				CString sFilename( pBuffer );
				int len = strlen( (const char*)pBuffer ) + 1;
				pBuffer += len; nBuffer -= len;

				CString sArtist, sAlbum, sCategory, sDate, sLanguage;
				IN_ADDR nAddress = {};
				WORD nPort = 0;
				BYTE pSHA1[ 20 ] = {};
				BOOL f = TRUE;
				while ( f && nBuffer )
				{
					BYTE nCode = *pBuffer;
					pBuffer ++;
					nBuffer --;
					switch ( nCode )
					{
					case 2:
						sArtist = pBuffer;
						len = strlen( (const char*)pBuffer ) + 1;
						pBuffer += len; nBuffer -= len;
						break;
					case 3:
						sAlbum = pBuffer;
						len = strlen( (const char*)pBuffer ) + 1;
						pBuffer += len; nBuffer -= len;
						break;
					case 4:
						sCategory = pBuffer;
						len = strlen( (const char*)pBuffer ) + 1;
						pBuffer += len; nBuffer -= len;
						break;
					case 5:
						sDate = pBuffer;
						len = strlen( (const char*)pBuffer ) + 1;
						pBuffer += len; nBuffer -= len;
						break;
					case 6:
						sLanguage = pBuffer;
						len = strlen( (const char*)pBuffer ) + 1;
						pBuffer += len; nBuffer -= len;
						break;
					case 7:
						nAddress.S_un.S_un_w.s_w1 = *(WORD*)(pBuffer + 0);
						nAddress.S_un.S_un_w.s_w2 = *(WORD*)(pBuffer + 2);
						pBuffer += 4; nBuffer -= 4;
						nPort = *(WORD*)pBuffer;
						pBuffer += 2; nBuffer -= 2;
						break;
					case 8:
						memcpy( pSHA1, pBuffer, 20 );
						pBuffer += 20; nBuffer -= 20;
						break;
					case 9:
						// 64-bit file size
						nFileSize = *(unsigned __int64*)pBuffer;
						pBuffer += 8; nBuffer -= 8;
						break;
					default:
						f = FALSE;
						foo.Format( _T("Unknown code: %d!\r\n"), nCode );
						m_sOutput += foo;
					}
				}

				if ( f && nBuffer != 0 )
					m_sOutput += _T("Invalid link!\r\n");

				foo.Format(
					_T("Filename: %s\r\n")
					_T("Size: %I64u bytes\r\n")
					_T("Artist: %s\r\n")
					_T("Album: %s\r\n")
					_T("Category: %s\r\n")
					_T("Date: %s\r\n")
					_T("Language: %s\r\n")
					_T("Host: %hs:%u\r\n")
					_T("SHA1 (base32): %s\r\n"),
					sFilename, nFileSize,
					sArtist, sAlbum, sCategory, sDate, sLanguage,
					inet_ntoa( nAddress ), nPort, toBase32( pSHA1, 20 ) );
				m_sOutput += foo;
			}
			else
				m_sOutput += _T("ZLib inflating error!\r\n");
		}
		else
			m_sOutput += _T("BASE64 decoding error!\r\n");
	}
	else
		m_sOutput += _T("No \"arlnk://\" prefix!\r\n");

	UpdateData( FALSE );
}
